<?php

use CloudPrinterPlugin\Services\ConfigService;

add_settings_field(
    'cp_product_price_margin_alert_percentage',
    __('% Minimum price margin (sends an alert)', 'cp_product_price_margin_alert_percentage'),
    'cpPriceMarginAlertRender',
    'cloudprinter',
    'cloudprinter_section'
);

function cpPriceMarginAlertRender()
{
    $configService = new ConfigService();
    $priceMarginAlertPercentage = $configService->getMinProductPriceMarginPercentageAlert();
    echo '
        <input name="cp_product_price_margin_alert_percentage" type="number" id="cp_product_price_margin_alert_percentage" value="' . $priceMarginAlertPercentage . '" class="regular-text">
        <p>
            <small>
                A safety feature that automatically sends you an email alert when the sales price of your product goes below a certain margin level.
                <br>
                We recommend to set a higher value than in the block "% Minimum Price Margin (blocks the order)"
                <br>
                Go to the <a href="/wp-admin/admin.php?page=wc-settings&tab=email" target="_blank">"WooCommerce -> Settings -> Emails"</a> to configure the revenue check email alert.

            </small>
        </p>
    ';
}
