<?php

use CloudPrinterPlugin\Helpers\FileHelper;

?>

<?php add_thickbox(); ?>

<div id='wk_cloudprinter_tab_data' class='panel woocommerce_options_panel'>
    <?php if (empty($apiKey)): ?>
    <p>
        You are required to login to your Cloudprinter.com account.
        You can do it in the <a href="<?php echo get_site_url() . '/wp-admin/options-general.php?page=cloudprinter'; ?>">general settings</a>
        of the cloudprinter plugin.
    </p>
    <?php else: ?>
        <input id="cp_product_file_required" type="hidden" name="cp_product_file_required">

        <p class=" form-field cp_product_category_field">
            <label for="cp_product_category">Product category</label>
            <select style="" id="cp_product_category" name="cp_product_category" class="select short">
                <option value="" disabled selected hidden>Select a category</option>
            </select>
        </p>

        <p id="cp_product_sub_category_field" class="form-field cp_product_sub_category_field" style="display: none">
            <label for="cp_product_category">Product sub category</label>
            <select style="" id="cp_product_sub_category" name="cp_product_sub_category" class="select short">
                <option value="" disabled selected hidden>Select a sub category</option>
            </select>
        </p>

        <div id="product_reference_field" style="display: none">
            <hr>
            <p class="form-field _product_reference_field">
                <label for="cp_product_reference">Product</label>
                <select style="" id="cp_product_reference" name="cp_product_reference" class="select short"></select>
                <a id="cp-price-check-btn" class="button" style="display: none">Check price</a>
            </p>
        </div>

        <div id="cp-product-options-type" style="display: none">
            <hr>
            <p class="form-field">
                <label for="cp_local_storage_file">Product option type</label>
                <input type="radio" id="cp_product_options_type_fixed" class="cp_product_options_type"
                       name="cp_product_options_type"
                       value="fixed" <?php echo !$productOptionsType || $productOptionsType == 'fixed' ? 'checked' : '' ?>>
                Fixed
                <br>
                <input type="radio" id="cp_product_options_type_dynamic" class="cp_product_options_type"
                       name="cp_product_options_type"
                       value="dynamic" <?php echo $productOptionsType == 'dynamic' ? 'checked' : '' ?>>
                Dynamic
            </p>
        </div>

        <div id="cp-product-options-fixed" style="display: none"></div>

        <div class="cp-product-config-field" id="cp-product-options-dynamic" style="display: none;">
            <hr>
            <div style="position: relative; float: left; width: 150px; padding-left: 11px;">Dynamic options</div>
            <div style="position: relative; float: left; width: 75%;" id="cp-product-options-dynamic-content"></div>
        </div>

        <div id="cp-product-options-general"></div>

        <p id="product_book_count_pages" class="form-field _product_book_count_pages_field" style="display: none; position: relative; float: left">
            <label for="cp_book_count_pages">Count pages</label>
            <input type="number" id="cp_book_count_pages" name="cp_book_count_pages">
        </p>

        <div id="product_quantity" class="cp-product-config-field" style="display: none;">
            <hr>
            <div id="quantity_type" style="display: none">
                <p class="form-field">
                    <label for="cp_local_storage_file">Quantity type</label>
                    <input type="radio" id="cp_quantity_type_single" class="cp_quantity_type" name="cp_quantity_type"
                           value="single" <?php echo $quantityType == 'single' ? 'checked' : '' ?>>
                    Flexible quantity
                    <br>
                    <input type="radio" id="cp_quantity_type_large" class="cp_quantity_type" name="cp_quantity_type"
                           value="large" <?php echo $quantityType == 'large' ? 'checked' : '' ?>>
                    Fixed quantity
                </p>
            </div>

            <p id="single_count_pieces" class="form-field count_pieces" style="display: none">
                <label for="cp_single_count_pieces">Quantity <span class="quantity_range"></label>
                <input type="number" id="cp_single_count_pieces" class="cp_count_pieces" name="cp_count_pieces"
                       value="<?= $countPieces ?>">
                <span class="count_pieces_warning"></span>
            </p>

            <p id="large_count_pieces" class="form-field count_pieces" style="display: none">
                <label for="cp_large_count_pieces">Quantity</label>
                <select id="cp_large_count_pieces" class="cp_count_pieces" name="cp_count_pieces"></select>
                <span class="count_pieces_warning"></span>
            </p>

        </div>

        <div id="cp-file-type" class="cp-product-config-field" style="display: none">
            <hr>
            <p class="form-field">
                <label for="cp_file_method">Printed product file.</label>
                <input type="radio" id="cp_file_method" class="cp_file_method" name="cp_file_method"
                       value="static" <?php echo $fileMethod == 'static' || empty($fileMethod) ? 'checked' : '' ?>>
                Static file. Provide the product file in advance.
                <br>

                <input type="radio" id="cp_file_method" class="cp_file_method" name="cp_file_method"
                       value="dynamic" <?php echo $fileMethod == 'dynamic' ? 'checked' : '' ?>>
                Dynamic file. The file will be uploaded by the end-customer on the checkout form.
                <br>

                <input type="radio" id="cp_file_method" class="cp_file_method" name="cp_file_method"
                       value="upload_later" <?php echo $fileMethod == 'upload_later' ? 'checked' : '' ?>>
                Manual file. Provide file after the order is created. (Be aware that for the current option the order will not be sent for print until the files are provided.)
                <br>

                <?php if (!empty($productDesigners)): ?>
                    <input type="radio" id="cp_file_method" class="cp_file_method" name="cp_file_method"
                           value="designer" <?php echo $fileMethod == 'designer' ? 'checked' : '' ?>>
                    Product designer. The user will create the design of printed product before adding to cart.
                    <br>
                <?php endif;?>

                <div id="dynamic_file" style="display: none">
                    <?php if (get_option('cp_dynamic_product_storage') === 'dropbox' && empty($dropboxAccessToken)): ?>
                        <p>* The Dropbox access token is not set in the Cloudprinter.com plugin settings.</p>
                    <?php endif; ?>
                </div>
            </p>
        </div>

        <div id="product_designer" class="cp-product-config-field" style="display: none">
            <?php if (!$productDesigners): ?>
                <p>No product designers available.</p>
            <?php else: ?>
                <hr>
                <p class="form-field">
                    <label for="cp_product_designer">Product designer</label>
                    <select id="cp_product_designer" style="width: 300px; margin-bottom: 10px;" name="cp_product_designer">
                        <option value="">Not selected</option>
                        <?php foreach ($productDesigners as $productDesignerInstance): ?>
                            <option value="<?php echo $productDesignerInstance->getAlias(); ?>" <?php echo $productDesigner == $productDesignerInstance->getAlias() ? 'selected' : '' ?>>
                                <?php echo $productDesignerInstance->getName() ?>
                            </option>
                        <?php endforeach; ?>
                    </select>
                </p>
                <hr>
                <p class="form-field product-designer-field">
                    <label for="cp_product_designer_project"><?php echo apply_filters('cloudprinter_product_designer_project_label_name', 'Project') ?></label>
                    <span id="cp_product_designer_project_field"></span>
                </p>
                <?php do_action('cloudprinter_admin_after_product_designer_options', $post) ?>
            <?php endif; ?>
        </div>

        <div id="cp-storage-type" class="cp_file cp-product-config-field" style="display: none">
            <hr>
            <p class="form-field">
                <label for="cp_local_storage_file">Storage</label>
                <input type="radio" id="cp_local_file_storage" class="cp_file_storage" name="cp_file_storage"
                       value="local" <?php echo $fileStorage != 'external' ? 'checked' : '' ?>>
                Upload the file
                <br>
                <input type="radio" id="cp_external_file_storage" class="cp_file_storage" name="cp_file_storage"
                       value="external" <?php echo $fileStorage == 'external' ? 'checked' : '' ?>>
                Set link
            </p>
        </div>

        <div id="local-storage-file" class="cp_file cp-product-config-field" style="display: none"></div>

        <div id="external-storage-file" class="cp_file cp-product-config-field" style="display: none"></div>
    <?php endif; ?>
</div>

<script>
    var apiKey = '<?php echo $apiKey;?>';
    var currency = '<?php echo get_woocommerce_currency();?>';
    var currencySymbol = '<?php echo get_woocommerce_currency_symbol();?>';
    var products,
        selectedCategory,
        selectedSubCategory,
        selectedProduct,
        selectedProductInfo,
        productCategories;

    // Use for edit product
    var cp_product_meta = {
        category: '<?php echo get_post_meta($post->ID, 'cp_product_category', true); ?>',
        product_reference: '<?php echo get_post_meta($post->ID, 'cp_product_reference', true); ?>',
        book_count_pages: '<?php echo get_post_meta($post->ID, 'cp_book_count_pages', true); ?>',
        count_pieces: '<?php echo get_post_meta($post->ID, 'cp_count_pieces', true); ?>',
        quantity_type: '<?php echo get_post_meta($post->ID, 'cp_quantity_type', true); ?>',
        predefined_quantity: '<?php echo get_post_meta($post->ID, 'cp_predefined_quantity', true); ?>',
        productFiles: <?php echo json_encode($productFiles)?>,
        product_options: {},
        product_options_dynamic: {},
        productDesignerProject: '<?php echo $productDesignerProject; ?>'
    }
    <?php
    $fixedOptions = unserialize(get_post_meta($post->ID, 'cp_product_options', true));
    $dynamicOptions = unserialize(get_post_meta($post->ID, 'cp_dynamic_product_options', true));

    // Prepare fixed product options.
    if (!empty($fixedOptions) && is_array($fixedOptions)) {
        foreach ($fixedOptions as $key => $value) {
            echo "cp_product_meta.product_options['$key'] = '$value';";
        }
    }

    // Prepare dynamic product option
    if (!empty($dynamicOptions) && is_array($dynamicOptions)) {
        foreach ($dynamicOptions as $optionReference => $optionParams) {
            echo "cp_product_meta.product_options_dynamic['$optionReference'] = {};";
            echo "cp_product_meta.product_options_dynamic." . $optionReference . "['option_name'] = '" . $optionParams['name'] . "';";
            echo "cp_product_meta.product_options_dynamic." . $optionReference . "['option_values'] = {};";
            echo "cp_product_meta.product_options_dynamic." . $optionReference . "['option_prices'] = {};";

            if (!empty($optionParams['values']) && is_array($optionParams['values'])) {
                foreach ($optionParams['values'] as $optionValue) {
                    echo "cp_product_meta.product_options_dynamic.$optionReference.option_values['$optionValue'] = '" . $optionParams['names'][$optionValue] . "';";

                    if (!empty($optionParams['prices'])) {
                        echo "cp_product_meta.product_options_dynamic.$optionReference.option_prices['$optionValue'] = '" . $optionParams['prices'][$optionValue]  . "';";
                    } else {
                        echo "cp_product_meta.product_options_dynamic.$optionReference.option_prices['$optionValue'] = '0';";
                    }
                }
            }
        }
    }
    ?>
</script>
